// ClientPart.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <winsock2.h>
#include <ws2tcpip.h>

#pragma comment (lib, "Ws2_32.lib")

// https://docs.microsoft.com/en-us/windows/win32/winsock/complete-client-code

#define DEFAULT_BUFLEN (1024 * 1024 * 10)
#define DEFAULT_PORT "15000"

void print(char buf[], int len, int errorCode)
{
    for (int i = 0; i < len; i++)
    {
        printf("%c", buf[i]);
    }

    printf(", ErrorCode = %d\n", errorCode);
}

int __cdecl main(int argc, char** argv)
{
    WSADATA wsaData;
    SOCKET clntSocket = INVALID_SOCKET;
    struct addrinfo* result = NULL,
        * ptr = NULL,
        hints;
    const char* sendbuf = "this is a test";
    char *recvbuf = (char *)malloc(DEFAULT_BUFLEN); // 테스트의 편의상 delete 생략
    int iResult;
    int recvbuflen = DEFAULT_BUFLEN;

    // Validate the parameters
    if (argc != 2) {
        printf("usage: %s server-name\n", argv[0]);
        return 1;
    }

    // Initialize Winsock
    iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
    if (iResult != 0) {
        printf("WSAStartup failed with error: %d\n", iResult);
        return 1;
    }

    ZeroMemory(&hints, sizeof(hints));
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_protocol = IPPROTO_TCP;

    // Resolve the server address and port
    iResult = getaddrinfo(argv[1], DEFAULT_PORT, &hints, &result);
    if (iResult != 0) {
        printf("getaddrinfo failed with error: %d\n", iResult);
        WSACleanup();
        return 1;
    }

    // Attempt to connect to an address until one succeeds
    for (ptr = result; ptr != NULL; ptr = ptr->ai_next) {

        // Create a SOCKET for connecting to server
        clntSocket = socket(ptr->ai_family, ptr->ai_socktype,
            ptr->ai_protocol);
        if (clntSocket == INVALID_SOCKET) {
            printf("socket failed with error: %ld\n", WSAGetLastError());
            WSACleanup();
            return 1;
        }

        // Connect to server.
        iResult = connect(clntSocket, ptr->ai_addr, (int)ptr->ai_addrlen);
        if (iResult == SOCKET_ERROR) {
            closesocket(clntSocket);
            clntSocket = INVALID_SOCKET;
            continue;
        }
        break;
    }

    freeaddrinfo(result);

    if (clntSocket == INVALID_SOCKET) {
        printf("Unable to connect to server!\n");
        WSACleanup();
        return 1;
    }

    int errorCode = 0;

    const char* pText = "12345";
    int pTextLen = strlen(pText);

    //printf("Press any key to call send");
    //getchar();

    //iResult = send(clntSocket, recvbuf, DEFAULT_BUFLEN, 0);
    //errorCode = WSAGetLastError();
    //printf("send: %d(%d)\n", iResult, errorCode);

    //printf("Press any key to call shutdown");
    //getchar();

    //iResult = shutdown(clntSocket, SD_SEND);
    //errorCode = WSAGetLastError();
    //printf("shutdown: %d(%d)\n", iResult, errorCode);

    printf("Press any key to call closesocket");
    getchar();

    iResult = closesocket(clntSocket);
    errorCode = WSAGetLastError();
    printf("closesocket: %d(%d)\n", iResult, errorCode);
    WSACleanup();

    return 0;
}